SystemOrganization addCategory: #'Constraints-Tests'!
SystemOrganization addCategory: #'Constraints-Core'!

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:45'!
alwaysTrue
	"This method constructs constraints for all solvable constraints inside this blockClosure."
	| newProcess |
	newProcess := self newTerminatingProcess.
	#ccm withLayerDo: [[newProcess step] doWhileFalse: [newProcess suspendedContext isNil]].
	newProcess terminate.! !

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:33'!
newTerminatingProcess
	"Answer a Process running the code in the receiver. The process is not 
	scheduled."
	<primitive: 19> "Simulation guard"
	^Process
		forContext: 
			[self value. self terminateProcess.] asContext
		priority: Processor activePriority! !

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:33'!
terminateProcess

	^ self! !

Object subclass: #Constraint
	instanceVariableNames: 'solver priority externalConstraint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!Constraint methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 12:02'!
< aConstraint

	self priority < aConstraint priority! !

!Constraint methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 11:46'!
<= aConstraint

	self priority <= aConstraint priority! !

!Constraint methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:12'!
externalConstraint

	^ externalConstraint! !

!Constraint methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:12'!
externalConstraint: anObject

	externalConstraint := anObject! !

!Constraint methodsFor: 'initialize-release' stamp: 'mg 4/16/2014 11:58'!
initialize

	priority := ConstraintPriority required.! !

!Constraint methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:12'!
priority

	^ priority! !

!Constraint methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:12'!
priority: anObject

	priority := anObject! !

!Constraint methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:12'!
solver

	^ solver! !

!Constraint methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:12'!
solver: anObject

	solver := anObject! !

!Constraint methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 13:16'!
triggerSolver
	"This method should be called, if this constraint changed, e.g., because a variable changed. It triggers the solver to solve all constraints. The solving process may raise an exception, if the constraints are unsatisfiable."
	self solver solve.! !

Object subclass: #ConstraintGenericVariable
	instanceVariableNames: 'constraint originalValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintGenericVariable commentStamp: 'mg 4/16/2014 13:02' prior: 0!
A ConstraintGenericVariable represents all values that are used inside a constraint but does not have a concrete ConstraintVariable.

Instance Variables
	constraint:		The constraint is needed to invalidate and recreate the constraint, if this generic variable changes its value.
	originalValue:	The original object
!

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:52'!
constraint

	^ constraint! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:52'!
constraint: anObject

	constraint := anObject! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:52'!
originalValue

	^ originalValue! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:52'!
originalValue: anObject

	originalValue := anObject! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:26'!
suggestValue: aValue
	"This method adds an equality constraint for the new value. If all constraints are still solvable, the value is changed to aValue. Otherwise, the old value does not change and an exception is raised. Generic variables are not supposed to be changed. If so, all corresponding constraints should be recreated."! !

!ConstraintGenericVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:27'!
value
	"Returns the value from the solver variable. A generic variable forwards all messages to the original object."! !

ConstraintGenericVariable subclass: #ConstraintVariable
	instanceVariableNames: 'externalVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintVariable commentStamp: 'mg 4/16/2014 13:07' prior: 0!
A ConstraintVariable is a concrete ConstraintVariable that does have a solver object for it.

Instance Variables
	externalVariable:	This is the solver object for the constraint variable.
!

!ConstraintVariable methodsFor: 'constraint-construction' stamp: 'mg 4/16/2014 12:52'!
+ aConstraintVariable
	"This method should return a linear expression"
	self originalValue: 2358.! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:21'!
externalVariable

	^ externalVariable! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:21'!
externalVariable: anObject

	externalVariable := anObject! !

!ConstraintVariable methodsFor: 'initialize-release' stamp: 'mg 4/16/2014 12:55'!
initialize

	originalValue := 42.! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:19'!
suggestValue: aValue
	"This method adds an equality constraint for the new value. If all constraints are still solvable, the value is changed to aValue. Otherwise, the old value does not change and an exception is raised."! !

!ConstraintVariable methodsFor: 'accessing' stamp: 'mg 4/16/2014 12:55'!
value
	"Returns the value from the solver variable."
	^ originalValue! !

Object subclass: #ConstraintLinearExpression
	instanceVariableNames: 'externalExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintLinearExpression methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:20'!
externalExpression

	^ externalExpression! !

!ConstraintLinearExpression methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:20'!
externalExpression: anObject

	externalExpression := anObject! !

Object subclass: #ConstraintPriority
	instanceVariableNames: 'name val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintPriority commentStamp: 'mg 4/16/2014 12:05' prior: 0!
A ConstraintPriority is a named priority object. It represents the priority of a constraint.

Instance Variables
	name:	symbolic name for a priority
	val:		a number for the priority to simplify comparisons between priorities 

!

!ConstraintPriority class methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 11:56'!
medium

	^ self new 
		name: 'medium';
		val: 2! !

!ConstraintPriority class methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 11:55'!
required

	^ self new 
		name: 'required';
		val: 0! !

!ConstraintPriority class methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 11:55'!
strong

	^ self new 
		name: 'strong';
		val: 1! !

!ConstraintPriority class methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 11:56'!
weak

	^ self new 
		name: 'weak';
		val: 3! !

!ConstraintPriority methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 12:02'!
< aConstraintPriority

	^ self val < aConstraintPriority val! !

!ConstraintPriority methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 11:58'!
<= aConstraintPriority

	^ self val <= aConstraintPriority val! !

!ConstraintPriority methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:57'!
name
		
	^ name! !

!ConstraintPriority methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:56'!
name: anObject

	name := anObject! !

!ConstraintPriority methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:56'!
val

	^ val! !

!ConstraintPriority methodsFor: 'accessing' stamp: 'mg 4/16/2014 11:56'!
val: anObject

	val := anObject! !

Object subclass: #ConstraintSolver
	instanceVariableNames: 'externalSolver constraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstraintSolver methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 13:13'!
addConstraint: aConstraint

	constraints add: aConstraint.
	self externalSolver addConstraint: aConstraint externalConstraint.
	self solve.! !

!ConstraintSolver methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:11'!
constraints

	^ constraints! !

!ConstraintSolver methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:11'!
constraints: anObject

	constraints := anObject! !

!ConstraintSolver methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:11'!
externalSolver

	^ externalSolver! !

!ConstraintSolver methodsFor: 'accessing' stamp: 'mg 4/16/2014 13:11'!
externalSolver: anObject

	externalSolver := anObject! !

!ConstraintSolver methodsFor: 'initialize-release' stamp: 'mg 4/16/2014 11:38'!
initialize

	externalSolver := ClSimplexSolver new.
	constraints := OrderedCollection new.! !

!ConstraintSolver methodsFor: 'as yet unclassified' stamp: 'mg 4/16/2014 13:20'!
solve
	"This method triggers the external solver to solve the constraints. It may raise an exception, if the constraints are unsatisfiable."
	self externalSolver solve.! !

Object subclass: #ExampleClass
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!ExampleClass methodsFor: 'accessing' stamp: 'mg 4/15/2014 14:31'!
a

	^ a! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 4/15/2014 14:31'!
a: anObject

	a := anObject! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 4/15/2014 14:31'!
b

	^ b! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 4/15/2014 14:31'!
b: anObject

	b := anObject! !

!ExampleClass methodsFor: 'initialize-release' stamp: 'mg 4/15/2014 14:33'!
initialize

	a := 1.
	b := 2.! !

TestCase subclass: #ConstraintsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/15/2014 14:12'!
testNoException

	self shouldnt: [[1 = 1] alwaysTrue] raise: Exception.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/16/2014 12:02'!
testPriorityOrder

	| p1 p2 p3 p4 |
	p1 := ConstraintPriority required.
	p2 := ConstraintPriority strong.
	p3 := ConstraintPriority medium.
	p4 := ConstraintPriority weak.

	self should: [p1 <= p2].
	self should: [p2 <= p3].
	self should: [p3 <= p4].

	self should: [p1 < p2].
	self should: [p2 < p3].
	self should: [p3 < p4].

	self shouldnt: [p1 < p1].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/15/2014 14:32'!
testSimpleAssignmentConstraint

	| ex |
	ex := ExampleClass new.
	[ex a = 42] alwaysTrue.
	self should: [ex a = 42].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/15/2014 14:24'!
testUnsatisfiableConstraints

	self should: [[1 = 2] alwaysTrue] raise: Exception.! !

!ContextPart methodsFor: '*Constraints' stamp: 'mg 4/16/2014 12:53'!
doPrimitive: primitiveIndex method: meth receiver: receiver args: arguments 
	"Simulate a primitive method whose index is primitiveIndex.  The
	 simulated receiver and arguments are given as arguments to this message.
	 If successful, push result and return resuming context, else ^ PrimitiveFailToken.
	 Any primitive which provokes execution needs to be intercepted and simulated
	 to avoid execution running away."
	<layer: #ccm>
	| value cv |
	"Judicious use of primitive 19 (a null primitive that doesn't do anything) prevents
	 the debugger from entering various run-away activities such as spawning a new
	 process, etc.  Injudicious use results in the debugger not being able to debug
	 interesting code, such as the debugger itself.  hence use primtiive 19 with care :-)"
	"SystemNavigation new browseAllSelect: [:m| m primitive = 19]"
	primitiveIndex = 19 ifTrue:
		[ToolSet 
			debugContext: self
			label:'Code simulation error'
			contents: nil].

	"ContextPart>>blockCopy:; simulated to get startpc right"
	(primitiveIndex = 80 and: [(self objectClass: receiver) includesBehavior: ContextPart]) 
		ifTrue: [^self push: ((BlockContext newForMethod: receiver method)
						home: receiver home
						startpc: pc + 2
						nargs: (arguments at: 1))].
	(primitiveIndex = 81 and: [(self objectClass: receiver) == BlockContext]) "BlockContext>>value[:value:...]"
		ifTrue: [^receiver pushArgs: arguments from: self].
	(primitiveIndex = 82 and: [(self objectClass: receiver) == BlockContext]) "BlockContext>>valueWithArguments:"
		ifTrue: [^receiver pushArgs: arguments first from: self].
	primitiveIndex = 83 "afr 9/11/1998 19:50" "Object>>perform:[with:...]"
		ifTrue: [^self send: arguments first
					to: receiver
					with: arguments allButFirst
					super: false].
	primitiveIndex = 84 "afr 9/11/1998 19:50 & eem 8/18/2009 17:04" "Object>>perform:withArguments:"
		ifTrue: [^self send: arguments first
					to: receiver
					with: (arguments at: 2)
					startClass: nil].
	primitiveIndex = 100 "eem 8/18/2009 16:57" "Object>>perform:withArguments:inSuperclass:"
		ifTrue: [^self send: arguments first
					to: receiver
					with: (arguments at: 2)
					startClass: (arguments at: 3)].

	"Mutex>>primitiveEnterCriticalSection
	 Mutex>>primitiveTestAndSetOwnershipOfCriticalSection"
	(primitiveIndex = 186 or: [primitiveIndex = 187]) ifTrue:
		[| active effective |
		 active := Processor activeProcess.
		 effective := active effectiveProcess.
		 "active == effective"
		 value := primitiveIndex = 186
					ifTrue: [receiver primitiveEnterCriticalSectionOnBehalfOf: effective]
					ifFalse: [receiver primitiveTestAndSetOwnershipOfCriticalSectionOnBehalfOf: effective].
		 ^((self objectClass: value) == Array
		    and: [value size = 2
		    and: [value first == PrimitiveFailToken]])
			ifTrue: [value]
			ifFalse: [self push: value]].

	primitiveIndex = 188 ifTrue: "eem 5/27/2008 11:10 Object>>withArgs:executeMethod:"
		[^MethodContext
			sender: self
			receiver: receiver
			method: (arguments at: 2)
			arguments: (arguments at: 1)].

	"Closure primitives"
	(primitiveIndex = 200 and: [self == receiver]) ifTrue:
		"ContextPart>>closureCopy:copiedValues:; simulated to get startpc right"
		[^self push: (BlockClosure
						outerContext: receiver
						startpc: pc + 2
						numArgs: arguments first
						copiedValues: arguments last)].
	((primitiveIndex between: 201 and: 205)			 "BlockClosure>>value[:value:...]"
	or: [primitiveIndex between: 221 and: 222]) ifTrue: "BlockClosure>>valueNoContextSwitch[:]"
		[^receiver simulateValueWithArguments: arguments caller: self].
	primitiveIndex = 206 ifTrue:						"BlockClosure>>valueWithArguments:"
		[^receiver simulateValueWithArguments: arguments first caller: self].

	primitiveIndex = 118 ifTrue: "tryPrimitive:withArgs:; avoid recursing in the VM"
		[(arguments size = 2
		 and: [arguments first isInteger
		 and: [(self objectClass: arguments last) == Array]]) ifFalse:
			[^ContextPart primitiveFailTokenFor: nil].
		 ^self doPrimitive: arguments first method: meth receiver: receiver args: arguments last].

	value := primitiveIndex = 120 "FFI method"
				ifTrue: [(meth literalAt: 1) tryInvokeWithArguments: arguments]
				ifFalse:
					[primitiveIndex = 117 "named primitives"
						ifTrue: [self tryNamedPrimitiveIn: meth for: receiver withArgs: arguments]
						ifFalse:
							[receiver tryPrimitive: primitiveIndex withArgs: arguments]].
	^((self objectClass: value) == Array
	    and: [value size = 2
	    and: [value first == PrimitiveFailToken]])
		ifTrue: [value]
		ifFalse: [meth isReturnField 
					ifTrue: [Transcript show: 'found instVarAccesor of instance '; show: receiver; cr.
						cv := ConstraintVariable new originalValue: value.
						self push: cv]
					ifFalse: [self push: value]]! !

!ContextPart methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:24'!
send: selector super: superFlag numArgs: numArgs
	"Simulate the action of bytecodes that send a message with selector, 
	selector. The argument, superFlag, tells whether the receiver of the 
	message was specified with 'super' in the source method. The arguments 
	of the message are found in the top numArgs locations on the stack and 
	the receiver just below them."
	<layer: #ccm>
	| receiver arguments |
	Transcript show: 'layer method send '; show: selector; cr.
	arguments := Array new: numArgs.
	numArgs to: 1 by: -1 do: [ :i | arguments at: i put: self pop].
	receiver := self pop.
	selector = '+' 
		ifTrue: [Transcript 
			show: 'send + aruments: '; show: arguments; 
			show: ' receiver: '; show: receiver; 
			cr].
	selector = 'terminateProcess' 
		ifTrue: [Transcript show: 'process is terminating'; cr. ^ nil].
	QuickStep == self ifTrue:
		[QuickStep := nil.
		^self quickSend: selector to: receiver with: arguments super: superFlag].
	^self send: selector to: receiver with: arguments super: superFlag! !
